; Robs BB-Kurs 2
; Robert Gerlach 12.2001
;
; Flchtlinge
; ----------------------------------------------
; Punkte per Maus durch die Gegend schieben.
; Maustaste drcken um Punkte zu verschieben.
; "N" drcken um wieder alles zurckzusetzen.






anzahl = 5000  ; Anzahl der Punkte
xscreen = 640 ; Auflsung des Bildschirms
yscreen = 480
radius = 50 ; Radius in dem die Punkte beeinflusst werden.

; Die Felder dimensionieren. Fr jeden Punkt eigene Werte
Dim x#(anzahl)
Dim y#(anzahl)
Dim punktwinkel#(anzahl)
Dim speed#(anzahl)


; Allen einen Wert zuweisen
For i = 1 To anzahl
x#(i) = Rnd(1,640)
y#(i) = Rnd(1,480)
Next

; Vorberechnete Sinus/Cosinus-Tabellen
; Ist sehr viel schneller als alles jedesmal neu auszurechnen.
Dim sinus#(360)
Dim cosinus#(360)
For i = 0 To 360
sinus#(i) = Sin(i)
cosinus#(i) = Cos(i)
Next





Graphics xscreen, yscreen, 16, 1
SetBuffer BackBuffer()


Color 255,0,0 ; Die Farbe fr den Punkt. Hier rot.
Repeat
Cls

; Der Punkt vor dem die anderen Flchten. Hier die Mauskoordinaten.
xflucht = MouseX()
yflucht = MouseY()


If KeyHit(49) Then   ; Bei 'n'-Druck
; Allen einen Wert zuweisen
For i = 1 To anzahl
x#(i) = Rnd(1,640)
y#(i) = Rnd(1,480)
Next
EndIf



LockBuffer BackBuffer(); Fr WritePixelFast wichtig.
; Alle Punkte durchgehen.
For i = 1 To anzahl


; Wenn Maustaste gedrckt ist, werden neue Positionen fr die Punkte berechnet.
If MouseDown(1) Then
punktwinkel#(i) = winkel#(xflucht, yflucht, x#(i), y#(i)) ; Winkel zwischen Maus und Punkt

; Geschwindigkeit der Punkte. Nahe am roten Punkt: schnell
speed#(i) = 10-(abstand(xflucht, yflucht, x#(i), y#(i)) /   (radius/10)  ) 
If abstand(xflucht, yflucht, x#(i), y#(i)) >    radius    Then speed#(i) = 0 ; Ab einem gewissen Abstand hren sie sich auf zu bewegen.

; Die neuen Punktkoordinaten errechnen.
x#(i) = xbewegen#(x#(i), punktwinkel#(i), speed#(i))
y#(i) = ybewegen#(y#(i), punktwinkel#(i), speed#(i))
EndIf


; Am Rand gehts nicht weiter...
If x#(i) > xscreen-1 Then x#(i) = xscreen-1
If x#(i) < 1 Then x#(i) = 1
If y#(i) > yscreen-1 Then y#(i) = yscreen-1
If y#(i) < 1 Then y#(i) = 1

WritePixelFast x#(i), y#(i), $FFFFFF
Next
UnlockBuffer BackBuffer()  ; Buffer wieder Unlocken.


; Den roten Punkt malen.
Oval xflucht-3, yflucht-3, 6, 6

Flip
Until KeyHit(1)
End

















; Einene Punkt(Stern) in eine Richtung bewegen.
Function xbewegen#(x#,winkel#,speed#)
x2# = x# + Cosinus#(winkel#)*speed#
Return x2#
End Function

; Das gleiche mit y#.
Function ybewegen#(y#,winkel#,speed#)
y2# = y# + Sinus#(winkel#)*speed#
Return y2#
End Function

Function abstand#(x1#,y1#,x2#,y2#)
xhypo# = x1# - x2#
yhypo# = y1# - y2#

; Sqr = Wurzel
abstand# = Abs(Sqr((xhypo# ^ 2) + (yhypo# ^2)))
Return abstand#
End Function


; Aus RGB-Werten einen ReadPixelFast-Farbwert errechnen. 
Function rgb(rot,gruen,blau)
Return blau Or (gruen Shl 8) Or (rot Shl 16)
End Function



; Errechnet den Winkel zwischen zwei Koordinaten.
Function winkel#(x1#,y1#,x2#,y2#)
xhypo# = x2# - x1#
yhypo# = y2# - y1#

; Sqr = Wurzel
abstand# = Abs(Sqr((xhypo# ^ 2) + (yhypo# ^2)))

winkel# = Abs(ACos(xhypo#/abstand#))

If Sgn(xhypo#) = -1 And Sgn(yhypo#) = -1 Then winkel# = 180 + (180 - winkel#)
If Sgn(xhypo#) = 1 And Sgn(yhypo#) = -1 Then winkel# = 270 + (90 - winkel#)

Return winkel#
End Function


